//-------------------------------------------------------------
/*Written by Lyle S, lyle@xkubed.com, contains original code, and code modified from the original "635 Linux Demonstration Code" from Crystalfontz America, inc.*/
//-------------------------------------------------------------
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>
#include "typedefs.h"
#include "serial.h"
#include "635_packet.h"
#include "show_packet.h"
#include "add_ons.h"
//-------------------------------------------------------------
/*clears the display*/
void clear_display()
{
    outgoing_response.command = 6;
    outgoing_response.data_length = 0;
    send_packet();
}

/*waits for response from lcd, if a packet is received it gets processed*/
void timeout_test()
{
	int
	k;
	int
	timed_out;
	timed_out = 1; //default timed_out is true
	for(int k=0;k<=10000;k++)
	if(check_for_packet())
		{
		printf("Received appropriate response.\n");
		ShowReceivedPacket();
		timed_out = 0; //set timed_out to false
		break;
		}
	if(timed_out)
	printf("Timed out waiting for a response.\n");
}

/*send a single line to the lcd. can display no more than 20 character at once*/
void send_line(int col, int row, char text[], int char_count)
{
	outgoing_response.command = 31;
	outgoing_response.data[0]=col; //col
	outgoing_response.data[1]=row; //row
	memcpy(&outgoing_response.data[2],text,char_count);
	outgoing_response.data_length = (2 + char_count);
	send_packet();
}

/*scrolling_row allows you to send the column and row number you want text
displayed to and checks if the text is longer that 20 characters, if it is
this module will cause the text to scroll across the screen until all 
characters have been displayed*/
void scrolling_row(int col, int row, char text[])
{
	int max_length = (20 - col);
	char full_row[max_length];
	int num_pulled_element = 0;
	int num_shifts;
	int char_count;
	int row_char_count = get_length(text);
	if(row_char_count > max_length)
	{
		char_count = max_length;
		num_shifts = (row_char_count - max_length);
	}
	else
	{
		char_count = row_char_count;
		num_shifts = 0;
	}
	
	for(int shifts=0; shifts <= num_shifts; shifts++)
	{
		for(int i=0; i<max_length; i++)
			{
			full_row[i] = text[(i + num_pulled_element)];
			}
	num_pulled_element++;
	outgoing_response.command = 31;
	outgoing_response.data[0]=col; //col
	outgoing_response.data[1]=row; //row
	memcpy(&outgoing_response.data[2],full_row,char_count);
	outgoing_response.data_length = (2 + char_count);
	send_packet();
	usleep(450000);
	timeout_test();
	}

}

/*gets the length of a character string and passes it back as an integer to the
calling function*/
int get_length(char row[])
{
	int element = 0;
	while (!(row[element] == '\0'))
	{
		element++;
	}
	return (element);
}

/*sends one character out of a string to the lcd, specify the column and row you want the character displayed to and the number of the element in the string*/
void send_character(int col, int row, char text[], int item)
{
	outgoing_response.command = 31;
	outgoing_response.data[0]=col; //col
	outgoing_response.data[1]=row; //row
	outgoing_response.data[2]=text[item];
	outgoing_response.data_length = (2 + 1);
	send_packet();
}
/*sends a single character to any point on the lcd by using the column and row number.*/
void send_character(int col, int row, char text)
{
	outgoing_response.command = 31;
	outgoing_response.data[0]=col; //col
	outgoing_response.data[1]=row; //row
	outgoing_response.data[2]=text;
	outgoing_response.data_length = (2 + 1);
	send_packet();
}
